-- Options:
displayTime = 2;    -- How long, in seconds, to display the message before it begins to fade out.
fadeTime = 1;       -- How long, in seconds, the message takes to fade out.
fontColor = Turbine.UI.Color.PaleGoldenrod;

import "Turbine"; 
import "Turbine.UI.Lotro"; 

Turbine.Shell.WriteLine("Friend Alert v" ..  plugin:GetVersion() .. ", by Thurallor");

Window = Turbine.UI.Window();
Window:SetVisible(true);
Window:SetMouseVisible(false);
Window:SetSize(Turbine.UI.Display.GetWidth(), 50);
Window:SetTop(math.floor((Turbine.UI.Display.GetHeight() - Window:GetHeight()) / 2));
Label = Turbine.UI.Label();
Label:SetParent(Window);
Label:SetMouseVisible(false);
Label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36);
Label:SetForeColor(fontColor);
Label:SetFontStyle(Turbine.UI.FontStyle.Outline);
Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
Label:SetSize(Window:GetSize());
Messages = {};

function enqueue(msg)
    table.insert(Messages, msg);
    Window:SetWantsUpdates(true);
end

function Window.Update()
    if ((not endTime) and (#Messages > 0)) then
        endTime = Turbine.Engine.GetGameTime() + displayTime + fadeTime;
        Label:SetText(table.remove(Messages, 1));
    else
        progress = (Turbine.Engine.GetGameTime() - (endTime - fadeTime)) / fadeTime;
        if (progress >= 1) then
            progress = 1;
            endTime = nil;
            if (#Messages == 0) then
                Window:SetWantsUpdates(false);
            end
        end
        Window:SetOpacity(math.min(1, 1 - progress));
    end
end

function parse(sender, args)
    if (string.match(args.Message, "^Your friend, ")) then
        enqueue(args.Message);
    end
end

if (type(Turbine.Chat.Received) == "table") then
    table.insert(Turbine.Chat.Received, parse);
else
    Turbine.Chat.Received = { parse, Turbine.Chat.Received };
end
